package com.example.modacon;

import java.util.concurrent.atomic.AtomicInteger;

public class ModbusRequest {
    public static AtomicInteger nextId = new AtomicInteger(0);
    
    public int     id, addr, reg, nregs;
    public int[]   values = null;
    public boolean updateRegs = false;
    
    // read request
    public ModbusRequest(int _addr, int _reg, int _nregs, boolean update){
        id = nextId.getAndIncrement();
        addr = _addr; reg = _reg; nregs = _nregs;
        updateRegs = update;
    }
    // write request
    public ModbusRequest(int _addr, int _reg, int _regs[], boolean update){
        id = nextId.getAndIncrement();
        addr = _addr; reg = _reg; nregs = _regs.length;
        values = _regs;
        updateRegs = update;
    }
    
    public byte[] getPacket(){
        return (values == null) ? ModbusRtu.create03(addr, reg, nregs) :
            ModbusRtu.create16(addr, reg, values);
    }
}
